/*-
 * Original code Copyright (c) 1987 Dave Buxbaum
 * Later Modifications Copyright (c) 1987-2000 Ken Marx, Nick Johnson
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */
#include <stdio.h>
#include <ctype.h>
#include <sys/time.h>
#include <sys/param.h>
#include <sys/types.h>
#include <regex.h>

#define MAXPHRASES	500
#define MAXPHRSLEN	160
#define ASIZE(a)	(sizeof(a)/sizeof(a[0]))

#define bcopy(s1, s2, n) memmove(s2, s1, n)
/*

*/

char	power_lead_ins[MAXPHRASES][MAXPHRSLEN] =
{
	"We need to",
	"Each and every one of us is willing to",
	"We all agree that we must",
	"Look, it is a given that we will",
	"This group must",
	"The ball is in our court, we need to",
	"As a company we must",
	"We are empowered to",
	"We have to move. We must",
	"Speaking candidly, I say that we intend to",
	"It is our mandate that we",
	"It is self-evident that we must",
	"It is undeniable that we should",
	"In order to make real progress we must",
	"I think it is urgent that we",
	"Clearly we must",
	"If we form a subcomittee we will",
	"No one doubts that we must",
	"We all agree that we must",
	"It is imperative that this group",
	"They must",
	"Relative to that, I feel we must",
	"Agree. Agree. But still we have to",
	"The entire team is behind the concept that we",
	"By end of this quarter we must",
	"Senior management agrees that we must",
	"Our management has said again and again that we must",
	"We are going to be selling flowers on the street if we do not",
	"We are in jeopardy if we do not",
	"It is critical that we each",
	"I am very concerned that we may not",
	"None of us will be here this time next year if we do not",
	"Even the simplist minds see the need to",
	"Only a fool would deny that we must",
	"It's wrong headed to",
	"It's an orthogonal issue to",
	"The big man upstairs told me that I must",
	"It's foolish to",
	"I feel it is too risky to",
	"It's too costly to",
	"Make no mistake, we're road kill if we don't",
	"We are at risk if we",
	"There is too much exposure when we do not",
	"It's imperative that we",
	"I insist that we",
	"It's a survival issue that we",
	"We urgently need to",
	"We are obligated to",
	"Is is a clear win when we",
	"Look, we absolutely must"
};

char	statements_of_work[MAXPHRASES][MAXPHRSLEN] =
{
	"get to work on the",
	"prototype the",
	"ramp up the",
	"step upto the plate on the",
	"go the whole nine yards in regarding the",
	"go to bat on the",
	"move aggressively on the",
	"re-engineer the process on the",
	"hammer on the",
	"take the lead on the",
	"get moving on the",
	"lay out in broad strokes the",
	"be accountable for the",
	"matrix manage the",
	"motivate the troops to",
	"eliminate redundancies in the",
	"stick with the",
	"get hopping on the",
	"display leadership on the",
	"keep the faith regarding the",
	"achieve sustainable competitive advantage on the",
	"move quickly to capitalize on the",
	"analyze the risks of the",
	"identify trends in the context of the",
	"set up weekly meetings on the",
	"micro-manage the",
	"keep all of us in the loop on",
	"objectify the",
	"mitigate risk on the",
	"set the agenda regarding",
	"drive to completion the",
	"identify the inch pebbles of the",
	"revise the expectations surrounding the",
	"achieve closure on",
	"optimize!, optimize!, optimize! the",
	"analyze progress on the",
	"slam dunk the",
	"stop beating around the bush on the",
	"rise to the task with regards to",
	"maintain our commitment to the",
	"achieve consensus about the",
	"focus hard to resolve the",
	"manage our customer's expectation regarding the",
	"examine where the rubber meets the road on the",
	"really focus on the",
	"reach critical mass regarding the",
	"finish the"
};

char	nouns[MAXPHRASES][MAXPHRSLEN] =
{
	"long pole in the tent",
	"problem domain",
	"problem space",
	"problem management",
	"problem resolution",
	"people issues",
	"family jewels",
	"architecture",
	"methodology",
	"startup mentality",
	"customer's customer",
	"re-useability",
	"communication issues",
	"current market acceptance",
	"continuous improvement process",
	"meta issues",
	"team building",
	"impedance match",
	"risk analysis",
	"market window",
	"market reality",
	"market forces",
	"appropriate changes",
	"inappropriate behaviour",
	"straw man",
	"outline",
	"requirements",
	"company knowledge base",
	"tradeoffs",
	"progress",
	"long term assets",
	"proper sense of urgency",
	"low hanging fruit",
	"critical resources",
	"solution space",
	"diminishing expectations",
	"object",
	"exposure",
	"cost reductions",
	"design",
	"staffing",
	"platform",
	"client/server issue",
	"our goal of customer satisfaction",
	"pay off",
	"project management",
	"realistic goals",
	"action items",
	"management issues",
	"strategic technology",
	"skill set",
	"solution domain",
	"technology evolution",
	"bandwith issues",
	"client expectations",
	"subsystem",
	"future",
	"milestones",
	"total quality",
	"strategy",
	"vision"
};

char	actions[MAXPHRASES][MAXPHRSLEN] =
{
	"sharpen our pencils",
	"establish strategic alliances",
	"stop thrashing",
	"do the right thing",
	"take the bull by horns",
	"not throw the baby out with the bath water",
	"not put the cart before the horse",
	"stop fighting fires",
	"get lean and mean",
	"not stand pat",
	"make not buy",
	"leverage our critical resources",
	"modify the current paradigm",
	"address the crazy aunt in the attic",
	"roll up our sleeves",
	"accept our fate",
	"open our kimono",
	"run it up the flagpole",
	"get our ducks in a line",
	"march shoulder to shoulder",
	"optimize",
	"focus",
	"vector",
	"round off the square corners",
	"eliminate the deadwood",
	"insure total quality",
	"establish realistic objectives",
	"work our fingers to the bones",
	"put our shoulders to the wheel",
	"put our noses to the grindstone",
	"put our heads together",
	"hoist the flag",
	"solidify our knowledge base",
	"guard the keys to the kingdom",
	"get down to business",
	"pull the trigger",
	"reach agreement",
	"form consensus",
	"hit the nail on the head",
	"crisp up",
	"outsource",
	"streamline the process",
	"right size",
	"down size",
	"leverage our skills",
	"cut to the chase",
	"cut costs",
	"increase productivity",
	"table this"
};

init_array(array, fname)
char array[MAXPHRASES][MAXPHRSLEN];
char *fname;
{
    char *getenv();
    char fpath[1024], phrase[MAXPHRSLEN+1], *cp;
    int i;
    FILE *f;

    if ((cp = getenv("SPEAKPATH")) == NULL)
	cp = SPEAKDATAPATH;

    strcpy(fpath, cp);
    strcat(fpath, "/");
    strcat(fpath, fname);

    if ((f = fopen(fpath, "r"))== NULL)
	return(-1);

    for (i=0; fgets(phrase, MAXPHRSLEN, f) != NULL && i< MAXPHRASES; i++) {
	phrase[strlen(phrase)-1] = '\0';
	bcopy(phrase, array[i], 1+strlen(phrase)); 	/* include NULL */
    }
    while (i < MAXPHRASES)
	array[i++][0] = '\0';

    return(0);
}

array_size(a)
char a[MAXPHRASES][MAXPHRSLEN];
{
    int i;

    for(i=0; i < MAXPHRASES && a[i][0] != '\0'; i++)
	;

    return(i);
}

/*
** Choose a random value between 0 and hval;
*/
randint(hval)
int	hval;
{
	long	l;

	l = rand();
	return( (int)(l % hval) );
}

#define MAXTRIES (10*1000)	/* -search: option so we know when to give up*/

main(ac, av)
int	ac;
char	**av;
{
    char	*type;
    char	*pos;
    char	speakln[MAXPATHLEN],
		tmpln[MAXPATHLEN];
    int rand_actions,rand_power_lead_ins,
	rand_nouns, rand_statements_of_work;
    struct  timeval  seed;
    struct  timezone zone;
    int len;
    int err;
    int numlns, cnt = 1, tries=0;
    int lineno = 0;
    int splitflg = 0;
    int i;
    char padstr[10];
    int padwidth = 0;
    char *regex_str = NULL;
    int regex_err;
    char *re_comp();
    regex_t regex;
    int regex_flags = (REG_ICASE | REG_NOSUB | REG_EXTENDED);

    gettimeofday( &seed, &zone );
    srand( seed.tv_usec );

    while (ac-- > 1) {

	if (isdigit(av[ac][0])) {
	    cnt = atoi(av[ac]);
	    numlns = cnt;

	} else if (strcmp(av[ac], "-split") == 0) {
		splitflg++;
	} else if (strcmp(av[ac], "-search") == 0) {
	    regex_str = av[ac+1];
	    if (regex_str == NULL || *regex_str == '\0' ||
		(regex_err = regcomp(&regex, regex_str, regex_flags)) != 0) {

		printf("'%s': invalid search pattern\n");
		exit(1);
	    }
	} else if (strcmp(av[ac], "-n") == 0) {
	    lineno = 1;		/* enable line numbering by starting non-zero */
	}
    }

    /* 
     * set up padstr for split lines if they're to be numbered.
     * use count + space for the ". " following the line number
     */
    if (lineno && splitflg) {
	padwidth = 3;	/* one digit + the dot-space */

	/* count powers of 10 for amout of extra padding */
	while (numlns /= 10) { 
	    padwidth++;
	}
	memset(padstr, ' ', padwidth);
	padstr[padwidth] = '\0';

	numlns = cnt; /* reset this in case it's ever used later */
    }

    /*
    srandom( getpid() );
    */

    init_array(actions, "speak.actions");
    init_array(nouns, "speak.nouns");
    init_array(power_lead_ins, "speak.leadins");
    init_array(statements_of_work, "speak.wrk");

    while (cnt) {
	rand_actions = randint(array_size(actions));

	rand_nouns = randint(array_size(nouns));

	rand_power_lead_ins = randint(array_size(power_lead_ins));

	rand_statements_of_work = randint(array_size(statements_of_work));


	speakln[0] = '\0';

	if (lineno) {
	    sprintf(speakln, "%*d. ", padwidth-2, lineno);
	}

	if (!randint(5))
		sprintf(&speakln[strlen(speakln)], "%c%s %s!!\n", 
			toupper(statements_of_work[rand_statements_of_work][0]),
			&(statements_of_work[rand_statements_of_work][1]) ,
			nouns[rand_nouns]);
	else {
		sprintf(&speakln[strlen(speakln)],
		    "%s ", power_lead_ins[rand_power_lead_ins]);
		sprintf(&speakln[strlen(speakln)], "%s and ",
			actions[rand_actions]);
		sprintf(&speakln[strlen(speakln)], "%s %s", 
			statements_of_work[rand_statements_of_work]
			,nouns[rand_nouns]);

		if (!randint(10))
		    sprintf(&speakln[strlen(speakln)], ", etc.\n");
		else
		    sprintf(&speakln[strlen(speakln)], ".\n");
		    
	}

	if (regex_str) {
	    /* regexec (preg, string, nmatch, pmatch, eflags)*/
	    if ((err = regexec(&regex, speakln, 0, 0, 0)) == REG_NOMATCH) {
		if (tries++ >= MAXTRIES) {
		    printf("Can't find any speak for '%s' after %d tries\n",
				regex_str, tries-1);
		    exit(1);
		}
		continue;
	    } else if (err != 0) {
		printf("re_exec error searching for '%s' in [%s]\n",
			regex_str, speakln);
		exit(1);
	    }
	}

	/*
	 * split output on line boundaries if requested 
	 */
	if (splitflg) {
		/*
		 * may happen more than once.
		 */
		len = 0;
		while (strlen(&speakln[len]) > 79) {

			strcpy(tmpln, speakln);
			/* 
			 * find a space at which to split
			 */

			pos = &tmpln[len+79];
			while (*pos != ' ')
				pos--;

			/* length of line up to split */

			len = pos-tmpln;
			bcopy(tmpln, speakln, len);

			/* copy the rest out (and do again if needed) */

			len++;
			pos++;
			speakln[len] = '\n';

			/*
			 * if numbering lines, pad out beginning of next line
			 */
			if (lineno) {
			    strcpy(&speakln[len+1], padstr);
			    len += strlen(padstr);
			}

			strcpy(&speakln[len+1], pos);
			
			/*
			 * if padded, subtract padding len out for correct
			 * length comparison in while loop. ugh.
			 */
			if (lineno) {
			    len -= strlen(padstr);
			}


		}
	}
		
	if (lineno) {
	    lineno++;
	}
	printf(speakln);
	cnt--;
    }
}
